
class Customer {

	// Accessors
	getFname() { return this.fname; }
	getLname() { return this.lname; }
	getPhone() { return this.phone; }
	getZipcode() { return this.zipcode; }

	// Derived Accessors
	getPhoneFormatted() {
		const p = this.getPhone();
		if (p.length !== 10)
			return p;
		return `(${p.slice(0, 3)}) ${p.slice(3, 6)}-${p.slice(6)}`;
	}
	toString() { return this.getPhoneFormatted() + ' -- ' + this.getZipcode() + ' -- ' + this.getFname() + ' -- ' + this.getLname(); }

	//Public
	headers() { return '   *Phone*      *Zipcode* *First* *Last*'; }

	equals(otherCust) {
		return this.getFname().equals(otherCust.getFname())
			&& this.getLname().equals(otherCust.getLname())
			&& this.getPhone().equals(otherCust.getPhone())
			&& this.getZipcode().equals(otherCust.getZipcode());
	}

	static sample1() {
		const data = [
			['Asha', 'Apollon', '1112223333', 55100],
			['Asha', 'Cyr', '9991231234', 55300],
			['Chin', 'Milo', '2229994444', 55100],
			['Riya', 'Apollon', '5553334444', 55300],
		];
		let customers = MyArray.fromSize(data.length);
		for (let i=0; i<data.length; i++) {
			let row = data[i];
			let cust = Customer.fromFnameLnamePhoneZip(row[0], row[1], row[2], row[3]);
			customers.set(i, cust);
		}
		return customers;
	}

	static fromFnameLnamePhoneZip(fname, lname, ph, zipcode) {
		let cust = new Customer();
		cust.fname = fname;
		cust.lname = lname;
		cust.phone = ph;
		cust.zipcode = zipcode;
		return cust;
	}
}

